#ifndef activeentryh
#define activeentryh

#include <qwidget.h>
#include <qlayout.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <qvaluelist.h>
#include <qdial.h>

#include "activeplaylist.h"
#include "common.h"
#include "misc.h"
#include "vu.h"

class ActiveEntry : public QWidget {
	Q_OBJECT

	protected:
		QGridLayout *layout;
		QLabel *label_index, *label_key, *label_length, *label_portcols;
		QPushButton *button_stop;
		QDial *dial_vol;

		ActivePlaylist *parent;
	
	public:
		ActiveEntry(ActivePlaylist *p, audio_entry *e, QString n, ChannelPortList cVSp, int v);
		~ActiveEntry();
		void updateData();
		void updateWidgets();
		void mousePressEvent(QMouseEvent *e);
		void show();

		VuMeter *vuMeter;
		audio_entry *audioEntry;
		ActiveEntry *next, *prev;
		uint index;
		bool showRemaining;
		bool hasBeenUpdated;

		QLabel *label_name;

		ChannelPortList ports;
		uint totalFrames, currentFrame;

	public slots:
		void stop();
};
#else
	class ActiveEntry;
#endif
