#ifndef activeplaylisth
#define activeplaylisth

#include <qwidget.h>
#include <qlayout.h>
#include <qscrollbar.h>
#include <qstring.h>
#include <qevent.h>
#include <qptrlist.h>
#include <qtimer.h>

#include "activeentry.h"
#include "misc.h"

class ActivePlaylist : public QWidget {
	Q_OBJECT

	private:
		QScrollBar *aScroll;
		QLabel *spacer;
		QTimer *timerFast;
		QTimer *timerSlow;

		QWidget *parent;

		bool isUpdatingGraphics;

	public:
		ActivePlaylist(QWidget *p, QScrollBar *scb);
		~ActivePlaylist();

		ActiveEntry *itemFirst, *itemLast;
		uint itemCount;

		void resizeEvent (QResizeEvent *);

		void addEntry(ActiveEntry *entry);
		void stop(ActiveEntry *entry);
		void stop(QString name);
		void remEntry(ActiveEntry *entry);
		void remFromList(ActiveEntry *entry);
		void openEntry(QString filename, QString name, ChannelPortList chnVSport, int volume, signed int repeat_count);
		void killAll();
		void killNum(int num);
		void timersStop();
		void timersStart();

	public slots:
		void updateScroll();
		void updateLayout();
		void updateGraphics();
		void updateData();
};
#else
	class ActivePlaylist;
#endif
