#include "activewindow.h"

ActiveWindow::ActiveWindow(MainWindow *p): QWidget(0, 0, WType_TopLevel), parent(p) {
	aScroll = new QScrollBar(Qt::Vertical, this);
	aPlaylist = new ActivePlaylist(this, aScroll);
    setCaption("TTtrigger - Active sounds window");
	resize(480,300);
}

ActiveWindow::~ActiveWindow() {
	delete aScroll;
	delete aPlaylist;
}

void ActiveWindow::keyPressEvent(QKeyEvent *e) {
	parent->keyPressEvent(e);
}

void ActiveWindow::keyReleaseEvent(QKeyEvent *e) {
	parent->keyReleaseEvent(e);
}

void ActiveWindow::resizeEvent(QResizeEvent *e) {
	int h = e->size().height();
	int w = e->size().width();
	int scrollw = aScroll->sizeHint().width();
	int availw = w - scrollw;

	aScroll->resize(scrollw, h);
	aScroll->move(availw, 0);

	aPlaylist->resize(availw, h);
	aPlaylist->move(0, 0);
}

void ActiveWindow::show() {
	QWidget::show();
	aPlaylist->updateLayout();
}
