#ifndef guiconfigh
#define guiconfigh

#include <qwidget.h>
#include <qfont.h>
#include <qcolor.h>
#include <qstringlist.h>
#include <qpushbutton.h>
#include <qlayout.h>
#include <qevent.h>
#include <qfile.h>
#include <qkeysequence.h>

#include "misc.h"
#include "mwindow.h"
#include "playlist.h"
#include "configwidgets.h"

enum entryType {None, Audio, Sep};

class GUIconfig : public QWidget {
	Q_OBJECT
	
	private:
		QGridLayout *layout;
		QPushButton *buttonOK, *buttonCancel;
		ConfigPortColors *widgetPortColors;
		MiscOpts *widgetMisc;

		void setupData();
		void setupWidgets();
	
		MainWindow *parent;
		Playlist *playlist;

	public:
		QString fileName;
		QFile file;

		bool saveOnClose;
		bool showRemaining;
		QColor unknownPort;
		PortColorList listPortColor;

		int key_ctrl, key_play_next, key_skip, key_alloff;
		int key_kill1, key_kill2, key_kill3, key_kill4, key_kill5, key_kill6;
		int key_kill7, key_kill8, key_kill9, key_kill10, key_kill11, key_kill12;

		GUIconfig();
		~GUIconfig();
		bool load();
		bool save(bool startTimers = true);
		void setDefaults();
		void setParent(MainWindow *p, Playlist *pl);

		static bool parseConfig(QString *inp, PortColorList *out);
		static bool parseConfig(QString *inp, ChannelPortList *out);
		static bool parseConfig(QString *inp, bool *out);
		static bool parseConfig(QString *inp, QStringList *list, QColor *out);
		static bool parseConfig(QString *inp, QFont *out);
		static bool parseConfig(QString *inp, int *out);

		void keyPressEvent (QKeyEvent *e);

		GrabKey *grabKey;
		ConfigKeys *configKeys;

	public slots:
		void show();
		void clickOK();
};
#else
	class GUIconfig;
#endif
