#ifndef JACKCTRL_H
#define JACKCTRL_H

#include "common.h"
#include "config.h"
#include "errmsg.h"

#ifdef __cplusplus
extern "C" {
#endif

int init_jackctrl(global_info* gi);
void stop_jackctrl(global_info *gi);
void setupPorts(global_info *gi);
void jack_shutdown(void* arg);
int jprocess(jack_nframes_t nframes, void *arg);
void add2buffer(global_info *gi, audio_entry *entry, jack_ringbuffer_t *ringbuf, int frames, int fade);
int set_samplerate(jack_nframes_t nframes, void *arg);
int set_jackbufsize(jack_nframes_t nframes, void *arg);
void* disk_read(void* arg);
void fillEntryBuffers(audio_entry *entry);
void destroy_audio_entry(audio_entry* entry);
void take_out_audio_entry(audio_entry *delEntry);
audio_entry *open_audio_entry(global_info *gi, const char *filename, const char *name, port_connection *connections, float volume, signed int repeat_count);
file_info *get_file_info(global_info* gi, const char* filename);
int get_rdlock(global_info *gi);
void release_rdlock(global_info *gi);

#ifdef __cplusplus
}
#endif

#endif
