#include <qapplication.h>

#include "jumpto.h"
#include "config.h"
#include "guiconfig.h"

extern GUIconfig *guicfg;

WidgetJumpTo::WidgetJumpTo(Playlist *p) : QPopupMenu(p), parent(p) {
	data = new QListBox(this);
	connect(data, SIGNAL(selected(QListBoxItem *)), this, SLOT(selected(QListBoxItem *)));
	connect(data, SIGNAL(clicked(QListBoxItem *)), this, SLOT(selected(QListBoxItem *)));
	data->setFixedWidth(50);
	data->setHScrollBarMode(QScrollView::AlwaysOff);
	insertItem(data);
}

void WidgetJumpTo::popup(QPoint point, PlaylistBase *dtP) {
	dataParent = dtP;

	wjtListBox *item;

	uint count = parent->itemCount;
	for(uint i = 0; i < count; i++) {
		item = new wjtListBox(data, i, "#" + QString::number(i));
		if(i == dataParent->index)
			data->setSelected(item, true);
	}

	QPopupMenu::popup(point);
}

void WidgetJumpTo::selected(QListBoxItem *i) {
	wjtListBox *item = (wjtListBox *) i;

	hide();

	dataParent->index = item->index;
	parent->moveItem(dataParent);
}

void WidgetJumpTo::hide() {
	QPopupMenu::hide();
	data->clear();
}

void WidgetJumpTo::keyPressEvent(QKeyEvent * e) {
	if(e->key() == guicfg->key_ctrl) {
		parent->keyModPressed = true;
		parent->updateButtonGraphics();
	}

	QPopupMenu::keyPressEvent(e);
}

void WidgetJumpTo::keyReleaseEvent(QKeyEvent * e){
	if(e->key() == guicfg->key_ctrl) {
		parent->keyModPressed = false;
		parent->updateButtonGraphics();
	}

	QPopupMenu::keyReleaseEvent(e);
}
