#ifndef jumptoh
#define jumptoh

#include <qwidget.h>
#include <qpopupmenu.h>
#include <qevent.h>
#include <qlistbox.h>

#include "playlist.h"
#include "playlistbase.h"

class wjtListBox;
class WidgetJumpTo;

class wjtListBox : public QListBoxText {
	public:
		wjtListBox(QListBox * listbox, uint i, const QString & text = QString::null) :
			QListBoxText(listbox, text), index(i) {  }
		uint index;
};

class WidgetJumpTo : public QPopupMenu {
	Q_OBJECT

	private:
		PlaylistBase *dataParent;
		Playlist *parent;
		QListBox *data;

	public:
		WidgetJumpTo(Playlist *p);

		void popup(QPoint point, PlaylistBase *dtP);

		void keyPressEvent(QKeyEvent *e);
		void keyReleaseEvent (QKeyEvent *e);

	public slots:
		void selected(QListBoxItem *i);
		void hide();
};
#else
	class wjtListBox;
	class WidgetJumpTo;
#endif
