#ifndef misch
#define misch

#include <qstring.h>
#include <qcolor.h>
#include <qlistbox.h>
#include <qvaluelist.h>
#include <qpixmap.h>
#include <qpainter.h>

class portVScolor {
	public:
		bool operator< (const portVScolor & s1);

		QString name;
		QColor color;
};

class channelVSport {
	public:
		bool operator< (const channelVSport & s1);

		uint channel;
		QString name;
};

class ListBoxPixmapExt : public QListBoxPixmap {
	public:
		ListBoxPixmapExt(const QString &text, const QColor &col, bool e = true);
		void updateColor(QColor c);
		void paint(QPainter *p);

		bool active, blueText;
		QColor color;
};

class ListBoxTextExt : public QListBoxText {
	public:
		ListBoxTextExt(const QString &text, bool e = true);
		void paint(QPainter *p);

		bool active, blueText;
};

typedef QValueList<portVScolor> PortColorList;
typedef QValueList<channelVSport> ChannelPortList;

QPixmap getPortCols(QWidget *widget, ChannelPortList *listChnPort);
QString key2string(int key);

#else
	class portVScolor;
	class channelVSport;
#endif
