#ifndef mwindowh
#define mwindowh

#include <qwidget.h>
#include <qpopupmenu.h>
#include <qfiledialog.h>
#include <qscrollbar.h>
#include <qtimer.h>

#include "playlist.h"
#include "playlistbase.h"
#include "activewindow.h"

class MainWindow : public QWidget {
	Q_OBJECT
	
	private:
		QMenuBar *menuBar;
		QPopupMenu *menu_edit, *menu_help, *menu_misc;

	public:
		MainWindow();
		~MainWindow();
		int run();

		QScrollBar *scroll;
		Playlist *playlist;
		PlaylistEntry *keyGrabber;
		QTimer *nullTimer;

		ActiveWindow *activeWindow;
		QFileDialog *dialogFile;

		void updateCaption();
		int getAvailHeight();
		void adjustWidth();

		QPopupMenu *menu_file;
		int saveOnCloseId;

	public slots:
		void file_save();
		void file_saveAs();
		void file_open();
		void file_new();
		void file_toggleSaveOnExit();

		void edit_killall();

		void misc_disconnect();
		void misc_connect();
		void misc_showActiveWindow();
		void misc_updateContents();

		void help_about();
		void help_aboutqt();

		void qappAboutToQuit();
		void closeEvent(QCloseEvent *e);
		void nullTimerTimeout();

		void keyPressEvent(QKeyEvent * e);
		void keyReleaseEvent (QKeyEvent * e);
		void resizeEvent(QResizeEvent *e);
};
#else
	class MainWindow;
#endif
