#ifndef playlistbaseh
#define playlistbaseh

#include <qwidget.h>
#include <qlayout.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <qvaluelist.h>
#include <qpixmap.h>

class Playlist;

class PBaseWidth {
	public:
		PBaseWidth() : width_index(0), width_name(0), width_center(0) { }

		int width_index, width_name, width_center;
};

class PlaylistBase : public QWidget {
	Q_OBJECT

	protected:
		Playlist *parent;
	
	public:
		PlaylistBase(Playlist *p);
		virtual ~PlaylistBase();
		virtual bool isEnabled();
		virtual void updateButtonGraphics();
		virtual void updateWidgets();
		virtual QString saveText();
		virtual void compareSize(PBaseWidth *width);
		virtual void adjustSize(PBaseWidth *width);

		virtual void mousePressEvent(QMouseEvent *e);
		virtual void mouseDoubleClickEvent(QMouseEvent *e);

		PlaylistBase *next, *prev;
		uint index;

		QHBoxLayout *layout;
		QLabel *label_current, *label_index, *label_name;
		QPushButton *button_moveDown, *button_moveUp;
		int errorFlag;
		bool isEntry;    // is PlaylistEntry?

	public slots:
		void moveUp();
		void moveDown();
};
#else
	class PBaseWidth;
	class PlaylistBase;
#endif
