#ifndef playlistentryh
#define playlistentryh

#include <qwidget.h>
#include <qlayout.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <qvaluelist.h>
#include <qpixmap.h>
#include <qtimer.h>
#include <qdial.h>
#include <qspinbox.h>

#include "playlistbase.h"
#include "misc.h"
#include "playlist.h"

#include "misc.h"

enum CurrentFlags {cBlank, cCurrent, cPrev, cNext};

class PEntryWidth : public PBaseWidth {
	public:
		PEntryWidth() : PBaseWidth(), width_length(0), width_filename(0), width_repeatcount(0), width_hotkey(0), width_portcols(0), width_play(0) {  }
		int width_length, width_filename, width_repeatcount, width_hotkey, width_portcols, width_play;
};

class PlaylistEntry : public PlaylistBase {
	Q_OBJECT

	public:
		PlaylistEntry(Playlist *p);
		~PlaylistEntry();

		void updateWidgets();
		void setEnabled(bool val);
		bool isEnabled();
		void updateButtonGraphics();
		void compareSize(PEntryWidth *width);
		void adjustSize(PEntryWidth *width);
		void setCFlag(CurrentFlags f);
		void pasteKey(int key);

		QLabel *label_length, *label_filename;
		QSpinBox *spinbox_repeatcount;
		QPushButton *button_play;
		QLabel *label_hotkey, *label_portcols;
		QDial *dial_vol;
		QTimer *timer;

		ChannelPortList listChnPort;

		QString filename;
		uint totalFrames;
		uint samplerate;
		uint channels;

		int hotkey;

		QString saveText();

		void mousePressEvent(QMouseEvent *e);
		void mouseDoubleClickEvent(QMouseEvent *e);

	public slots:
		void timeout();
		void play();
};

#else
	class PEntryWidth;
	class PlaylistEntry;
#endif
