#include "playlistsep.h"
#include "images.h"

extern Images *appImages;

PlaylistSep::PlaylistSep(Playlist *p, QString name) : PlaylistBase(p) {
	QFont hFont;
	hFont.setWeight(QFont::Bold);
	label_index->setFont(hFont);

	if(hFont.pixelSize() == -1)
		hFont.setPointSize(((int) (hFont.pointSize() * 1.6)));
	else
		hFont.setPixelSize(((int) (hFont.pixelSize() * 1.6)));
	label_name->setFont(hFont);

	label_name->setText(name);

	layout->addStretch();
	layout->add(label_current);
	layout->add(label_index);
	layout->add(label_name);
	layout->add(button_moveUp);
	layout->add(button_moveDown);
	layout->addStretch();

	label_name->setAlignment(Qt::AlignCenter);

	button_moveDown->setFlat(TRUE);
	button_moveUp->setFlat(TRUE);

	button_moveDown->setFocusPolicy(QWidget::NoFocus);
	button_moveUp->setFocusPolicy(QWidget::NoFocus);
}

void PlaylistSep::adjustSize(PBaseWidth *width) {
	PlaylistBase::adjustSize(width);

	int w = width->width_center + layout->spacing() * 7;
	if(label_name->sizeHint().width() > w)
		w = label_name->sizeHint().width();
	label_name->setFixedWidth(w);
}
