#include <qsize.h>

#include "popupmenu.h"
#include "playlistentry.h"
#include "config.h"
#include "guiconfig.h"

extern GUIconfig *guicfg;

PopupMenu::PopupMenu(Playlist *p) : QPopupMenu(p), parent(p) {
	insertItem("Insert &entry...", this, SLOT(insertEntry()));
	insertItem("Insert &separator...", this, SLOT(insertSep()));
	insertItem("&Remove", this, SLOT(removeThis()));
}

void PopupMenu::popup(QPoint point, PlaylistBase *dtP) {
	dataParent = dtP;
	QPopupMenu::popup(point);
}

void PopupMenu::keyPressEvent(QKeyEvent *e) {
	if(e->key() == guicfg->key_ctrl) {
		parent->keyModPressed = true;
		parent->updateButtonGraphics();
	}

	QPopupMenu::keyPressEvent(e);
}

void PopupMenu::keyReleaseEvent(QKeyEvent * e){
	if(e->key() == guicfg->key_ctrl) {
		parent->keyModPressed = false;
		parent->updateButtonGraphics();
	}

	QPopupMenu::keyReleaseEvent(e);
}

void PopupMenu::insertEntry() {
	parent->getFilename_s(dataParent, false);
}

void PopupMenu::insertSep() {
	parent->addSep(dataParent);
}

void PopupMenu::removeThis() {
	parent->remEntry(dataParent);
}
