#ifndef vuh
#define vuh

#include <qwidget.h>
#include <qtimer.h>
#include <qevent.h>
#include <qsize.h>
#include <qpixmap.h>

#include "activeentry.h"

class VuMeter : public QWidget {
	Q_OBJECT

	private:
		static const int vuHeight = 7;

		uint numOfData;
		QPixmap *buffer;

		ActiveEntry *parent;
		float *data;
		bool peak;

	public:
		VuMeter(ActiveEntry *p, int num);
		~VuMeter();
		void setData(float *d);
		void paintEvent(QPaintEvent *);
		void mousePressEvent(QMouseEvent *);
		QSize sizeHint();

		QTimer *timer;

	public slots:
		void updateGraphic();
};
#else
	class VuMeter;
#endif
